diff --git a/man/man8/ip-address.8.in b/man/man8/ip-address.8.in
index b9a476a5fc7f8..c35509fe5c4ed 100644
--- a/man/man8/ip-address.8.in
+++ b/man/man8/ip-address.8.in
@@ -209,8 +209,8 @@ The maximum allowed total length of label is 15 characters.
 .BI scope " SCOPE_VALUE"
 the scope of the area where this address is valid.
 The available scopes are listed in
-.BR "@SYSCONF_USR_DIR@/rt_scopes" or
-.BR "@SYSCONF_ETC_DIR@/rt_scopes" (has precedence if exists).
+.BR @SYSCONF_USR_DIR@/rt_scopes " or " @SYSCONF_ETC_DIR@/rt_scopes
+(has precedence if exists).
 Predefined scope values are:
 
 .in +8
diff --git a/man/man8/ip-link.8.in b/man/man8/ip-link.8.in
index e82b2dbb00706..97f75cca09bfd 100644
--- a/man/man8/ip-link.8.in
+++ b/man/man8/ip-link.8.in
@@ -2261,8 +2261,8 @@ give the device a symbolic name for easy reference.
 .BI group " GROUP"
 specify the group the device belongs to.
 The available groups are listed in
-.BR "@SYSCONF_USR_DIR@/group" or
-.BR "@SYSCONF_ETC_DIR@/group" (has precedence if exists).
+.BR @SYSCONF_USR_DIR@/group " or " @SYSCONF_ETC_DIR@/group
+(has precedence if exists).
 
 .TP
 .BI vf " NUM"
@@ -2872,8 +2872,7 @@ specifies which help of link type to display.
 .SS
 .I GROUP
 may be a number or a string from
-.B @SYSCONF_USR_DIR@/group or
-.B @SYSCONF_ETC_DIR@/group
+.BR @SYSCONF_USR_DIR@/group " or " @SYSCONF_ETC_DIR@/group
 which can be manually filled and has precedence if exists.
 
 .SH "EXAMPLES"
diff --git a/man/man8/ip-route.8.in b/man/man8/ip-route.8.in
index f9ed4918cd1e8..10387bca66ff3 100644
--- a/man/man8/ip-route.8.in
+++ b/man/man8/ip-route.8.in
@@ -357,8 +357,8 @@ normal routing tables.
 .B Route tables:
 Linux-2.x can pack routes into several routing tables identified
 by a number in the range from 1 to 2^32-1 or by name from
-.B @SYSCONF_USR_DIR@/rt_tables or
-.B @SYSCONF_ETC_DIR@/rt_tables (has precedence if exists).
+.BR @SYSCONF_USR_DIR@/rt_tables " or " @SYSCONF_ETC_DIR@/rt_tables
+(has precedence if exists).
 By default all normal routes are inserted into the
 .B main
 table (ID 254) and the kernel only uses this table when calculating routes.
@@ -421,8 +421,8 @@ may still match a route with a zero TOS.
 .I TOS
 is either an 8 bit hexadecimal number or an identifier
 from
-.BR "@SYSCONF_USR_DIR@/rt_dsfield" or
-.BR "@SYSCONF_ETC_DIR@/rt_dsfield" (has precedence if exists).
+.BR @SYSCONF_USR_DIR@/rt_dsfield " or " @SYSCONF_ETC_DIR@/rt_dsfield
+(has precedence if exists).
 
 .TP
 .BI metric " NUMBER"
@@ -437,8 +437,8 @@ is an arbitrary 32bit number, where routes with lower values are preferred.
 the table to add this route to.
 .I TABLEID
 may be a number or a string from
-.BR "@SYSCONF_USR_DIR@/rt_tables" or
-.BR "@SYSCONF_ETC_DIR@/rt_tables" (has precedence if exists).
+.BR @SYSCONF_USR_DIR@/rt_tables " or " @SYSCONF_ETC_DIR@/rt_tables
+(has precedence if exists).
 If this parameter is omitted,
 .B ip
 assumes the
@@ -479,8 +479,8 @@ covered by the route prefix.
 the realm to which this route is assigned.
 .I REALMID
 may be a number or a string from
-.BR "@SYSCONF_USR_DIR@/rt_realms" or
-.BR "@SYSCONF_ETC_DIR@/rt_realms" (has precedence if exists).
+.BR @SYSCONF_USR_DIR@/rt_realms " or " @SYSCONF_ETC_DIR@/rt_realms
+(has precedence if exists).
 
 .TP
 .BI mtu " MTU"
@@ -631,8 +631,8 @@ command.
 the scope of the destinations covered by the route prefix.
 .I SCOPE_VAL
 may be a number or a string from
-.BR "@SYSCONF_USR_DIR@/rt_scopes" or
-.BR "@SYSCONF_ETC_DIR@/rt_scopes" (has precedence if exists).
+.BR @SYSCONF_USR_DIR@/rt_scopes " or " @SYSCONF_ETC_DIR@/rt_scopes
+(has precedence if exists).
 If this parameter is omitted,
 .B ip
 assumes scope
@@ -652,8 +652,8 @@ routes.
 the routing protocol identifier of this route.
 .I RTPROTO
 may be a number or a string from
-.BR "@SYSCONF_USR_DIR@/rt_protos" or
-.BR "@SYSCONF_ETC_DIR@/rt_protos" (has precedence if exists).
+.BR @SYSCONF_USR_DIR@/rt_protos " or " @SYSCONF_ETC_DIR@/rt_protos
+(has precedence if exists).
 If the routing protocol ID is not given,
 .B ip assumes protocol
 .B boot
@@ -892,8 +892,8 @@ matching packets are dropped.
 specified lookup table.
 .I TABLEID
 is either a number or a string from
-.BR "@SYSCONF_USR_DIR@/rt_tables" or
-.BR "@SYSCONF_ETC_DIR@/rt_tables" (has precedence if exists).
+.BR @SYSCONF_USR_DIR@/rt_tables " or " @SYSCONF_ETC_DIR@/rt_tables
+(has precedence if exists).
 If
 .B vrftable
 is used, the argument must be a VRF device associated with
@@ -909,8 +909,8 @@ and an inner IPv6 packet. Other matching packets are dropped.
 specified lookup table.
 .I TABLEID
 is either a number or a string from
-.BR "@SYSCONF_USR_DIR@/rt_tables" or
-.BR "@SYSCONF_ETC_DIR@/rt_tables" (has precedence if exists).
+.BR @SYSCONF_USR_DIR@/rt_tables " or " @SYSCONF_ETC_DIR@/rt_tables
+(has precedence if exists).
 The argument must be a VRF device associated with the table id.
 Moreover, the VRF table associated with the table id must be configured
 with the VRF strict mode turned on (net.vrf.strict_mode=1). This action
@@ -923,8 +923,8 @@ at all, and an inner IPv4 packet. Other matching packets are dropped.
 to the specified lookup table.
 .I TABLEID
 is either a number or a string from
-.BR "@SYSCONF_USR_DIR@/rt_tables" or
-.BR "@SYSCONF_ETC_DIR@/rt_tables" (has precedence if exists).
+.BR @SYSCONF_USR_DIR@/rt_tables " or " @SYSCONF_ETC_DIR@/rt_tables
+(has precedence if exists).
 The argument must be a VRF device associated with the table id.
 Moreover, the VRF table associated with the table id must be configured
 with the VRF strict mode turned on (net.vrf.strict_mode=1). This action